
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_maximum 50
#property indicator_minimum -50
#property indicator_level1  0
#property indicator_level2  15
#property indicator_level3  -15

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double WprPeriod       = 40;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double wprUp[];
double wprDn[];
double wpr[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,wprUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,wprDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,wpr);
   SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"   William%R36 With Alert("+DoubleToStr(WprPeriod,2)+")");
return(0);
} 

int deinit() 
{  
   Comment("");
   
return(0);
} 
 
//+------------------------------------------------------------------+
//| Williams? Percent Range                                          |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { wprUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {  
     for (i=limit; i>=0; i--)
     {
         double hi   = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
         double lo   =  Low[iLowest(NULL,  0,MODE_LOW,WprPeriod,i)];
         if (hi!=lo)      
              wpr[i] = 50+(-100)*(hi - Close[i]) / (hi - lo);
         else wpr[i] = 0;
         
         //
         //
         //
         //
         //
         
         wprUp[i] = EMPTY_VALUE;
         wprDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
           if (wpr[i] > 0) trend[i] = 1; 
           if (wpr[i] < 0) trend[i] =-1;
           if (trend[i] == 1) { wprUp[i] = wpr[i]; Comment ("BUY SWITCH ON","i ",i,"W[i] ",wpr[i],"W[i+1] ",wpr[i+1]); }
           if (trend[i] ==-1) { wprDn[i] = wpr[i]; Comment ("SELL SWITCH ON","i ",i,"W[i] ",wpr[i],"W[i+1] ",wpr[i+1]);}  
        }        
       manageAlerts();
       return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            wpr[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,2,y);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,3,y);
            wprUp[i] = EMPTY_VALUE;
            wprDn[i] = EMPTY_VALUE;
            if (trend[i] == 1) { wprUp[i] = wpr[i]; Comment ("BUY SWITCH ON","i ",i,"W[i] ",wpr[i],"W[i+1] ",wpr[i+1]); }
            if (trend[i] ==-1) { wprDn[i] = wpr[i]; Comment ("SELL SWITCH ON","i ",i,"W[i] ",wpr[i],"W[i+1] ",wpr[i+1]);}    
      }
      manageAlerts();  
return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)                          doAlert(whichBar,"Says B U Y");
         if (trend[whichBar] ==-1)                          doAlert(whichBar,"Says S E L L");
         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Willy ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Willy "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}



